// ===========================================================================
// CONTENT  : CLASS NodeElementSpy
// AUTHOR   : Manfred Duchrow
// VERSION  : 1.0 - 22/09/2002
// HISTORY  :
//  22/09/2002  duma  CREATED
//
// Copyright (c) 2002, by Manfred Duchrow. All rights reserved.
// ===========================================================================
package org.pf.joi.xml ;

// ===========================================================================
// IMPORTS
// ===========================================================================
import org.pf.joi.AbstractObjectSpy;
import org.pf.joi.ElementSpy;
import org.w3c.dom.Node;

/**
 * Model object for an org.w3c.dom.Node.
 *
 * @author Manfred Duchrow
 * @version 1.0
 */
class NodeElementSpy extends ElementSpy
{
  // =========================================================================
  // CONSTANTS
  // =========================================================================

  // =========================================================================
  // INSTANCE VARIABLES
  // =========================================================================
  private Node childNode = null ;
  protected Node getChildNode() { return childNode ; }
  protected void setChildNode( Node newValue ) { childNode = newValue ; }
  
  // =========================================================================
  // CONSTRUCTORS
  // =========================================================================
  /**
   * Initialize the new instance with default values.
   */
  public NodeElementSpy( AbstractObjectSpy object, Node child )
  {
    super( object ) ;
    this.setChildNode( child ) ;
  } // NodeElementSpy()

  // =========================================================================
  // PUBLIC INSTANCE METHODS
  // =========================================================================
  /**
   * Returns the name of the inspected object
   */
	public String getName()
	{
		String str = "" ;
		
		switch ( this.getChildNode().getNodeType() )
		{
			case Node.ELEMENT_NODE :
				str = "<" + this.getChildNode().getNodeName() + ">" ;
				break ;
			case Node.ATTRIBUTE_NODE :
				str = "@" + this.getChildNode().getNodeName() ;
				break ;
			default :
				str = this.getChildNode().getNodeName() ; 
		}
		return str ;		
	} // getName()

	// --------------------------------------------------------------------------

	/**
	 * Returns the type of the holded object.
	 */
	public Class getType()
	{
		return this.getChildNode().getClass() ;
	} // getType()

	// -------------------------------------------------------------------------

	/**
	 * Returns the value of the holded object.
	 */
	public Object getValue()
		throws Exception 
	{
		return this.getChildNode() ;
	} // getValue()

	// -------------------------------------------------------------------------

  // =========================================================================
  // PROTECTED INSTANCE METHODS
  // =========================================================================

  // -------------------------------------------------------------------------

} // class NodeElementSpy