// ===========================================================================
// CONTENT  : CLASS NodeInspector
// AUTHOR   : Manfred Duchrow
// VERSION  : 1.0 - 22/09/2002
// HISTORY  :
//  22/09/2002  duma  CREATED
//
// Copyright (c) 2002, by Manfred Duchrow. All rights reserved.
// ===========================================================================
package org.pf.joi.xml ;

// ===========================================================================
// IMPORTS
// ===========================================================================
import org.pf.joi.AbstractObjectSpy;
import org.pf.joi.BasicInspector;

/**
 * The inspector implementation for org.w3c.dom.Node.
 *
 * @author Manfred Duchrow
 * @version 1.0
 */
public class NodeInspector extends BasicInspector
{
  // =========================================================================
  // CONSTRUCTORS
  // =========================================================================
  /**
   * Initialize the new instance with default values.
   */
  public NodeInspector()
  {
    super() ;
  } // NodeInspector()

  // =========================================================================
  // PUBLIC INSTANCE METHODS
  // =========================================================================

  // =========================================================================
  // PROTECTED INSTANCE METHODS
  // =========================================================================
  protected AbstractObjectSpy objectSpyFor( Object obj )
  {
    return ( new NodeSpy( obj ) ) ;
  } // objectSpyFor()

  // -------------------------------------------------------------------------

  protected String getInspectorId()
  {
    return "NodeInspector" ;
  } // getInspectorId()

  // -------------------------------------------------------------------------

} // class NodeInspector