// ===========================================================================
// CONTENT  : CLASS NodeRenderer
// AUTHOR   : Manfred Duchrow
// VERSION  : 1.0 - 22/09/2002
// HISTORY  :
//  22/09/2002  duma  CREATED
//
// Copyright (c) 2002, by Manfred Duchrow. All rights reserved.
// ===========================================================================
package org.pf.joi.xml ;

// ===========================================================================
// IMPORTS
// ===========================================================================
import org.pf.joi.ObjectRenderer;
import org.w3c.dom.Attr;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;

/**
 * Renders a org.w3c.dom.Element to a String.
 *
 * @author Manfred Duchrow
 * @version 1.0
 */
public class NodeRenderer implements ObjectRenderer
{
  // =========================================================================
  // CONSTANTS
  // =========================================================================


  // =========================================================================
  // INSTANCE VARIABLES
  // =========================================================================

  // =========================================================================
  // CLASS METHODS
  // =========================================================================


  // =========================================================================
  // CONSTRUCTORS
  // =========================================================================
  /**
   * Initialize the new instance with default values.
   */
  public NodeRenderer()
  {
    super() ;
  } // NodeRenderer()

  // =========================================================================
  // PUBLIC INSTANCE METHODS
  // =========================================================================

  // =========================================================================
  // PROTECTED INSTANCE METHODS
  // =========================================================================
  /**
   * Returns the string representation of the specified object.
   *
   * @param obj Must be a org.w3c.dom.Node !
   */
  public String inspectString( Object obj )
  {
  	Node node ;
  	StringBuffer buffer ;
  	
  	node = (Node)obj ;
  	buffer = new StringBuffer( 80 ) ; 
  	
  	switch ( node.getNodeType() )
  	{
  		case Node.ELEMENT_NODE :		  		
		  	buffer.append( '<' ) ;
		  	buffer.append( node.getNodeName() ) ;
		  	this.addAttributes( buffer, node ) ;
		  	buffer.append( '>' ) ;
		  	break ;
		  default :
		  	buffer.append( node.getNodeValue() ) ;
  	}
		return buffer.toString() ;
  } // inspectString()  

  // -------------------------------------------------------------------------

	protected void addAttributes( StringBuffer buffer, Node node )
	{
    NamedNodeMap attributes ;
    Attr attr ;

    attributes = node.getAttributes() ;
    if ( attributes != null )
    {
	    for ( int index = 0 ; index < attributes.getLength() ; index++ )
	    {
	    	attr = (Attr)attributes.item( index ) ;
	    	buffer.append( ' ' ) ;
	    	buffer.append( attr.getNodeName() ) ;
	    	buffer.append( "=\"" ) ;
	    	buffer.append( attr.getNodeValue() ) ;
	    	buffer.append( '"' ) ;
	    }
    }		
	} // addAttributes()

	// -------------------------------------------------------------------------
	
} // class NodeRenderer